import java.util.ArrayList;
import java.util.function.Function;

public class Map<X,Y> {

	protected ArrayList<X> source;
	protected Function<X,Y> func;
	protected ArrayList<Y> target;
	
	Map(ArrayList<X> source,
		Function<X,Y> func,
		ArrayList<Y> target) {
		this.source = source;
		this.func = func;
		this.target = target;
	}
	
	public void map() {
		for (int i=0 ; i< source.size(); i++) {
			target.set(i, func.apply(source.get(i)));
		}
	}	
}
